# -*- coding: utf-8 -*-
#########################################################################
#                                                                       #
#                                                                       #
#########################################################################
#                                                                       #
# Copyright (C) 2009-2012  Akretion, Emmanuel Samyn						#
#                                                                       #
#This program is free software: you can redistribute it and/or modify   #
#it under the terms of the GNU General Public License as published by   #
#the Free Software Foundation, either version 3 of the License, or      #
#(at your option) any later version.                                    #
#                                                                       #
#This program is distributed in the hope that it will be useful,        #
#but WITHOUT ANY WARRANTY; without even the implied warranty of         #
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          #
#GNU General Public License for more details.                           #
#                                                                       #
#You should have received a copy of the GNU General Public License      #
#along with this program.  If not, see <http://www.gnu.org/licenses/>.  #
#########################################################################

import urllib, urllib2, time
from osv import fields, osv
from tools.translate import _

from lxml import etree


# To upgrade payment_order with external payment details and export method
class account_payment(osv.osv):
    _name = 'account.payment'
    _inherit = 'account.payment'
    _columns = {
        'external_payment': fields.many2one('external.payment', 'External payment',required=True,help="Create a default external payement with your main bank account"),
    }

    # Method to prepare and send the payment order
    def export_payment_order(self, cr, uid, ids,context=None,cc_details=None):   	
        print "ctx : ",context
        print "cc_details : ",cc_details
        # TODO : Fix cc_details / context bug !

        for order in self.browse(cr, uid,ids):
            print "order: ",order
            if not order.line_ids:
            	raise osv.except_osv(_('Error !'), _('You need to create at least on payment line !'))
            else:
            	create_url = order.external_payment.create_url
            	update_url = order.external_payment.update_url
            	payment_line_obj = self.pool.get('payment.line')       	
            	for line in order.line_ids:
					# TEST export_state !!!! if
					#===== GET URL =====
            		url = create_url
            		opertation_type = "create"
            		if line.type == "refund_in" or line.type == "refund_out" :
            			url = update_url  
            			opertation_type = "update"

					#===== GET VALUES ===== 

#================= TO REFACTOR =======================================================
# TODO : TO REFACTOR "values" TO IMPLEMENT DIFFERENT SERVICE PROVIDER (currently only for OGONE)
            		
            		values = {'PSPID' : order.external_payment.account,
            			'USERID' : order.external_payment.user,
          				'PSWD' : order.external_payment.password,
          				}
            		print "operation type: ",opertation_type
            		if opertation_type == "create":
            			values['ORDERID'] = order.reference # TODO ADD LINE_ID			
            			values['AMOUNT'] = int(line.amount_currency*100)
            			values['CURRENCY'] = line.currency.name
            			values['OPERATION'] = 'SAL'
            			values['COM'] = line.communication
            			values['CN'] = line.partner_id.name
            			values['EMAIL'] = 'customer@cust.fr' #line.partner_id.
#          				'SHASIGN' : 'value3',          				
#          				'ECOM_PAYMENT_C ARD_VERIFICATION' : 'value2',
#          				'OWNERADDRESS' : 'value3',
#          				'OWNERZIP' : 'value3',
#          				'OWNERTOWN' : 'value3',
#          				'OWNERCITY' : 'value2',
#          				'OWNERTELNO' : 'value3',          				 
#          				'GLOBORDERID' : 'value3',
#          				'WITHROOT' : 'value2',
#          				'REMOTE_ADDR' : 'value3',
#          				'RTIMEOUT' : 'value3',
#          				'ECI' : 'value3',         			

            			print "test : ",cc_details != 'none'
            			if cc_details != 'none':
            				print "CC DETAILS : ",context
            				values['CARDNO'] = cc_details['card_number'] # 'CARDNO' : '1234567890',
            				print "card num : ",values['CARDNO']
            				values['ED'] = '0113' # cc_details['card_expiration_date'] # ,
            				values['CVC'] = cc_details['card_vc'] # '' : '512',
            				values['CN'] = cc_details['name']
            			else:
            				print "TO DO champs virement bancaire" 					
            		else:					
          				#values['PAYID'] = line.origin_operation_id # "12952914" => avoid PAYID might be easier for refund based on online shop operation
          				values['ORDERID'] = order.reference 
          				values['AMOUNT'] = int(line.amount_currency*100)
          				values['OPERATION'] = 'RFD'

            		print "values: ",values
            		print "url: ",url
            		resp_content = "Empty"
#======================== END REFACTOR ====================================================

            		#===== CALL WEB SERVICE (POST request) =====
            		try:
            			data = urllib.urlencode(values)        
            			req = urllib2.Request(url, data)
            			response = urllib2.urlopen(req)
            			resp_content = response.read() 
            			print resp_content 
            		except Exception, detail: 
            			print "Err ", detail 
            		#===== TREATE WS RESPONSE =====  
            		payment_line_obj.write(cr,uid,[line.id],{'export_message' : resp_content,})
            		
#================= TO REFACTOR =======================================================            		
            		print "================= TREATE RESPONSE ======================================"
            		xml = etree.fromstring(resp_content)
            		attributes = xml.attrib
#            		print "xml : ",xml
#            		print "tostring : ",etree.tostring(xml)
#            		print "tag : ",xml.tag
            		print "attrib : ",xml.attrib
 #           		print "tail : ",xml.tail
 #           		print "text : ",xml.text
   	
            		export_status = "export_confirmed"
            		if attributes['STATUS']=='0':
            			export_status = "export_error"
            		payment_line_obj.write(cr,uid,[line.id],{'export_message' : resp_content,
            												'export_operation_id' : attributes['PAYID'],
            												'export_state': export_status,})
#======================== END REFACTOR ====================================================
        return True 

account_payment()

# To upgrade payment_line with type & export state details
class payment_line(osv.osv):
    _name = 'payment.line'
    _inherit = 'payment.line'
    _columns = {
        'type': fields.selection([
            ('payment_out', 'Make a supplier payment'),
            ('payment_in', 'Request a customer payment'),
            ('refund_in', 'Request a supplier refund'),
            ('refund_out', 'Make a customer refund')], 'Payment type', select=True, help=''),
        'export_state': fields.selection([
            ('to_export', 'To export'),
            ('export_waiting_response', 'Waiting export response'),
            ('export_error', 'Export error'),
            ('export_confirmed', 'Export confirmed')], 'Export state', select=True, help=''),
        'export_message' : fields.text('Export message', help="Feedback mesage from the order export",readonly=True),
        'origin_operation_id': fields.char('Origin ID', size=128, help="ID required by external provider to process update"), 
        'export_operation_id': fields.char('Operation ID', size=128, help="ID sent back by external provider"),        
    }
    
    _defaults = {
        'export_state': 'to_export',
        'type': 'payment_out',
    }
payment_line()
