# -*- coding: utf-8 -*-
#########################################################################
#                                                                       #
#                                                                       #
#########################################################################
#                                                                       #
# Copyright (C) 2009-2012  Akretion, Emmanuel Samyn						#
#                                                                       #
#This program is free software: you can redistribute it and/or modify   #
#it under the terms of the GNU General Public License as published by   #
#the Free Software Foundation, either version 3 of the License, or      #
#(at your option) any later version.                                    #
#                                                                       #
#This program is distributed in the hope that it will be useful,        #
#but WITHOUT ANY WARRANTY; without even the implied warranty of         #
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          #
#GNU General Public License for more details.                           #
#                                                                       #
#You should have received a copy of the GNU General Public License      #
#along with this program.  If not, see <http://www.gnu.org/licenses/>.  #
#########################################################################

import urllib, urllib2, time
from osv import fields, osv
from tools.translate import _

from lxml import etree


# To upgrade payment_order with external payment details and export method
class account_voucher(osv.osv):
    _name = 'account.voucher'
    _inherit = 'account.voucher'
    
    def _get_export_type(self, cr, uid, context=None):
		# Default check on voucher journal type. If not check voucher type and eventually set default to customer payment request
		voucher = self.browse(cr, uid, context)[0]
		try:
			if context['journal_type'] == "sale":
				return 'payment_in'
			elif context['journal_type'] == "sale_refund":
				return 'refund_out'
			elif context['journal_type'] == "purchase":
				return 'payment_out'
			elif context['journal_type'] == "purchase_refund":
				return 'refund_in' 
		except Exception, e:
			return 'payment_in'
        
    _columns = {
    	# TODO : refactor external_payment => external_referential
        'external_payment_method': fields.many2one('external.payment', 'External payment method',help="Create a default external payement with your main bank account"),
        'export_type': fields.selection([
            ('payment_in', 'Request a customer payment'),
            ('refund_out', 'Make a customer refund'),
            ('payment_out', 'Make a supplier payment'),
            ('refund_in', 'Request a supplier refund'),], 'Payment type', select=True, help=''),
        'export_state': fields.selection([
            ('to_export', 'To export'),
            ('export_failed', 'Export failed'),
            ('export_ok_waiting_response', 'Waiting export response'),
            ('export_ok_error', 'Export response : error'),
            ('export_ok_confirmed', 'Export response : confirmed')], 'Export state', select=True, help=''),
        'export_message' : fields.text('Export message', help="Feedback message from the order export",readonly=True),
        'origin_operation_id': fields.char('Origin ID', size=128, help="ID required by external provider to process update (refunds)"), 
        'export_operation_id': fields.char('Operation ID', size=128, help="ID sent back by external provider"), 
    }

    _defaults = {
        'export_state': 'to_export',
        'export_type': _get_export_type,
    }

	# TODO : REFACTOR DANS _ogone    
    # Method to prepare and send the payment order
    def export_payment_order(self, cr, uid, ids,context=None,cc_details=None):   	
        for voucher in self.browse(cr, uid,ids):
        	if not voucher.external_payment_method or not voucher.export_type:
        		raise osv.except_osv(_('Error !'), _('You need to set an external payment and a payment type !'))
        	else :
	        	create_url = voucher.external_payment_method.create_url
    	    	update_url = voucher.external_payment_method.update_url
    	    	print "type : ",voucher.type
    	    	#===== GET URL =====
    	    	url = create_url
    	    	opertation_type = "create"
    	    	if voucher.export_type == "refund_in" or voucher.export_type == "refund_out" :
    	    		url = update_url
    	    		opertation_type = "update"
#					# TEST export_state !!!! if
				#===== GET VALUES ===== 

#================= TO REFACTOR =======================================================
# TODO : TO REFACTOR "values" TO IMPLEMENT DIFFERENT SERVICE PROVIDER (currently only for OGONE)
            		
    	    	values = {'PSPID' : voucher.external_payment_method.account,
            			'USERID' : voucher.external_payment_method.user,
          				'PSWD' : voucher.external_payment_method.password,
          				}
    	    	print "operation type: ",opertation_type
    	    	if opertation_type == "create":
    	    		values['ORDERID'] = voucher.reference # TODO ADD LINE_ID			
    	    		values['AMOUNT'] = int(voucher.amount*100)
    	    		values['CURRENCY'] = voucher.company_id.currency_id.name
    	    		values['OPERATION'] = 'SAL'
    	    		values['COM'] = voucher.name
    	    		values['CN'] = voucher.partner_id.name
    	    		values['EMAIL'] = 'customer@cust.fr' #line.partner_id.
##          				'SHASIGN' : 'value3',          				
##          				'ECOM_PAYMENT_C ARD_VERIFICATION' : 'value2',
##          				'OWNERADDRESS' : 'value3',
#          				'OWNERZIP' : 'value3',
#          				'OWNERTOWN' : 'value3',
#          				'OWNERCITY' : 'value2',
#          				'OWNERTELNO' : 'value3',          				 
#          				'GLOBORDERID' : 'value3',
#          				'WITHROOT' : 'value2',
#          				'REMOTE_ADDR' : 'value3',
#          				'RTIMEOUT' : 'value3',
#          				'ECI' : 'value3',         			

    	    		print "test cc_details: ",cc_details != None
    	    		print "cc_details: ",cc_details
    	    		if cc_details != None:
    	    			print "CC DETAILS : ",context
    	    			values['CARDNO'] = cc_details['card_number'] # 'CARDNO' : '1234567890',
    	    			print "card num : ",values['CARDNO']
    	    			values['ED'] = '0113' # cc_details['card_expiration_date'] # ,
    	    			values['CVC'] = cc_details['card_vc'] # '' : '512',
    	    			values['CN'] = cc_details['name']
    	    		else:
    	    			print "TO DO champs virement bancaire" 					
    	    	else:
    	    		print "update"					
    	    		values['PAYID'] = voucher.origin_operation_id # "12952914" => avoid PAYID might be easier for refund based on online shop operation
    	    		values['ORDERID'] = voucher.reference 
    	    		values['AMOUNT'] = int(voucher.amount*100)
    	    		values['OPERATION'] = 'RFD'

    	    	print "values: ",values
    	    	print "url: ",url
    	    	resp_content = "Empty"
    	    	call_is_success = False
#======================== END REFACTOR ====================================================

    	    	#===== CALL WEB SERVICE (POST request) =====
    	    	try:
    	    		data = urllib.urlencode(values)        
    	    		req = urllib2.Request(url, data)
    	    		response = urllib2.urlopen(req)
    	    		resp_content = response.read() 
    	    		print "RESPONSE : ",resp_content 
    	    		call_is_success = True
    	    	except Exception, detail: 
    	    		print "Err ", detail
    	    		resp_content = detail
    	    	#===== TREATE WS RESPONSE =====  
            		
#================= TO REFACTOR =======================================================            		
    	    	print "================= TREATE RESPONSE ======================================"
    	    	if call_is_success:
        			xml = etree.fromstring(resp_content)
        			attributes = xml.attrib
        			print "xml : ",xml
         			print "tag : ",xml.tag
        			print "attrib : ",xml.attrib
        			print "tail : ",xml.tail
        			print "text : ",xml.text
   	
       				export_status = "export_ok_confirmed"
       				if attributes['STATUS']=='0':
       					export_status = "export_ok_error"
       				self.write(cr,uid,ids,{'export_message' : resp_content,
    	   								'export_operation_id' : attributes['PAYID'],
    	   								'export_state': export_status,})
    	    	else:
					self.write(cr,uid,ids,{'export_message' : resp_content,
    	   								'export_state': 'export_failed',})
				
#======================== END REFACTOR ====================================================
        return True 

account_voucher()
