# -*- coding: utf-8 -*-
#########################################################################
#                                                                       #
#                                                                       #
#########################################################################
#                                                                       #
# Copyright (C) 2009-2011  Akretion, Emmanuel Samyn                     #
#                                                                       #
#This program is free software: you can redistribute it and/or modify   #
#it under the terms of the GNU General Public License as published by   #
#the Free Software Foundation, either version 3 of the License, or      #
#(at your option) any later version.                                    #
#                                                                       #
#This program is distributed in the hope that it will be useful,        #
#but WITHOUT ANY WARRANTY; without even the implied warranty of         #
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          #
#GNU General Public License for more details.                           #
#                                                                       #
#You should have received a copy of the GNU General Public License      #
#along with this program.  If not, see <http://www.gnu.org/licenses/>.  #
#########################################################################

from osv import fields, osv
import pooler
import time

# Class to create a picking in from selected return lines
class get_credit_card_details(osv.osv_memory):
    _name='get_credit_card_details.wizard'
    _description='Wizard to '
    _columns = {
        'name': fields.char('Card holder', size=128, required=True),
        'card_number': fields.char('Card number', size=64, required=True),
        'card_expiration_month': fields.char('Expiration month', size=2, required=True),
        'card_expiration_year': fields.char('Expiration year', size=2, required=True),
        'card_vc': fields.char('Card verification code', size=64, required=True),
        'voucher_id': fields.many2one('account.voucher', 'Voucher'),
    }

    # Get payment order from payment order form
    def _get_default_payment_order_id(self, cr, uid, context):
        if 'active_id' in context:
            return self.pool.get('account.voucher').browse(cr,uid,context['active_id']).id
        return False

    # Get customer name
    def _get_customer_name(self, cr, uid, context):
        if 'active_id' in context:
            return self.pool.get('account.voucher').browse(cr,uid,context['active_id']).partner_id.name
        return False
                         
    _defaults = {
        'voucher_id': _get_default_payment_order_id,
        'name': _get_customer_name,
        'card_number': lambda *a: '4111 1111 1111 1111',
        'card_expiration_month': lambda *a: '10',
        'card_expiration_year': lambda *a: '14',
        'card_vc':lambda *a: '987',

#==================== OGONE Test details ==========
# Visa Brand : 4111 1111 1111 1111
# Visa 3D Brand : 4000 0000 0000 0002
# American Express Brand : 3741 1111 1111 111
# MasterCard Brand : 5399 9999 9999 9999
# Diners Brand : 3625 5695 5800 17
# Bancontact/Mister Cash Brand : 67030000000000003

# Visa Purchasing Brand : 4484 1200 0000 0029
# American Express Purchasing Brand : 3742 9101 9071 995
# Any expiry date in a near future may be used and any 3 digit CVC code. (4 digits for American Express and no CVC code for purchasing cards)
#================================================

    }     
        
    # If "Cancel" button pressed
    def action_cancel(self,cr,uid,ids,conect=None):
        return {'type': 'ir.actions.act_window_close',}

    # If "Create" button pressed
    def action_create_payment_order_export(self, cr, uid, ids, context=None):       
        for voucher in self.browse(cr, uid,ids):
            cc_details = {'card_number' : voucher.card_number,
          				'name' : voucher.name,
          				'card_expiration_date' : voucher.card_expiration_month + '/' + voucher.card_expiration_year,
          				'card_vc' : voucher.card_vc
            }
            voucher.voucher_id.export_payment_order(context=context,cc_details=cc_details)
            self.unlink(cr,uid,ids)
        
        return {'type': 'ir.actions.act_window_close',}
                              
get_credit_card_details()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
